Subject: 26.1; Bug in add-dir-local-variable when used with eval, progn and setenv

From: Luis Gerhorst <[email-masked]>
Date: Thu, 12 Jul 2018 01:07:17 +0200

(1) Open Emacs with emacs -Q
(2) Type the following code into *scratch*

    (add-dir-local-variable
     'c-mode
     'eval
     '(progn (make-local-variable 'process-environment)
             (setq process-environment (copy-sequence process-environment))
             (setenv "TEST" "hello")))

(3) M-x eval-buffer

Expected .dir-locals.el contents:
((c-mode (eval . (progn (make-local-variable 'process-environment)
                        (setq process-environment (copy-sequence process-environment))
                        (setenv "TEST" "hello")))))

Actual contents:
((c-mode (eval progn (make-local-variable 'process-environment)
                     (setq process-environment (copy-sequence process-environment))
                     (setenv "TEST" "hello"))))

When I open a C file and inspect process-environment, TEST is not set.

When I manually create a .dir-locals.el with the expected contents, it
works.

Please correct me if I'm using add-dir-local-variable wrong, I was not
able to find a version that works as expected with the above
progn. Strangely, if I use (progn (message "hello")), instead of the
progn with setenv, "hello" gets printed every time I open a C file.

Configured using:
 'configure --prefix=/home/cip/2016/un65esoq/local'

Configured features:
XPM JPEG TIFF GIF PNG RSVG IMAGEMAGICK SOUND GPM DBUS GSETTINGS NOTIFY
ACL LIBSELINUX GNUTLS LIBXML2 FREETYPE M17N_FLT LIBOTF XFT ZLIB
TOOLKIT_SCROLL_BARS GTK3 X11 THREADS LCMS2

Important settings:
  value of $LC_ALL: en_US.UTF-8
  value of $LC_CTYPE: C.UTF-8
  value of $LC_MESSAGES: C.UTF-8
  value of $LC_MONETARY: de_DE.UTF-8
  value of $LC_NUMERIC: de_DE.UTF-8
  value of $LC_TIME: de_DE.UTF-8
  value of $LANG: en_US.UTF-8
  locale-coding-system: utf-8-unix